Index: trunk/zoo-kernel/service_internal.c
===================================================================
--- trunk/zoo-kernel/service_internal.c	(revision 8)
+++ trunk/zoo-kernel/service_internal.c	(revision 9)
@@ -1937,25 +1232,23 @@
 
   tmp=getMap(s,"text");
-  xmlNodePtr nc1 = xmlNewNode(ns, BAD_CAST "ExceptionText");
+  nc1 = xmlNewNode(ns, BAD_CAST "ExceptionText");
+  nc2=NULL;
   if(tmp!=NULL){
-    xmlAddChild(nc1,xmlNewText(BAD_CAST tmp->value));
-  }
-  else
-    xmlAddChild(nc1,xmlNewText(BAD_CAST "No debug message available"));
-  
+    xmlNodeSetContent(nc1, BAD_CAST tmp->value);
+  }
+  else{
+    xmlNodeSetContent(nc1, BAD_CAST "No debug message available");
+  }
   xmlAddChild(nc,nc1);
   xmlAddChild(n,nc);
   xmlDocSetRootElement(doc, n);
 
-  xmlDocDumpFormatMemory(doc, &xmlbuff, &buffersize, 1);
-  printf((char *) xmlbuff);
+  xmlDocDumpFormatMemoryEnc(doc, &xmlbuff, &buffersize, encoding, 1);
+  printf("%s",xmlbuff);
+  fflush(stdout);
+  xmlFreeDoc(doc);
   xmlFree(xmlbuff);
-  xmlFree(ns_ows);
-  xmlFree(nr);
-  xmlFree(nc1);
-  xmlFree(nc);
-  xmlFree(n);
-  xmlFree(ns);
-  xmlFree(doc);
+  xmlFreeNs(ns);
+  xmlCleanupParser();
 }
 
@@ -1972,6 +1265,29 @@
   if(toto!=NULL)
     asRaw=1;
-   
+  
   if(asRaw==0){
+#ifdef DEBUG
+    fprintf(stderr,"REQUEST_OUTPUTS FINAL\n");
+    dumpMaps(request_outputs);
+#endif
+    toto=getMap(request_outputs->content,"asReference");
+    if(toto!=NULL && strcasecmp(toto->value,"true")==0){
+      toto=getMap(request_outputs->content,"extension");
+      map *tmp1=getMapFromMaps(m,"main","tmpPath");
+      char *file_name=(char*)malloc((strlen(tmp1->value)+strlen(s->name)+strlen(toto->value)+13)*sizeof(char));
+      sprintf(file_name,"%s/%s_%i.%s",tmp1->value,s->name,cpid+100000,toto->value);
+      FILE *ofile=fopen(file_name,"w");
+      map *tmp2=getMapFromMaps(m,"main","tmpUrl");
+      map *tmp3=getMapFromMaps(m,"main","serverAddress");
+      char *file_url=(char*)malloc((strlen(tmp3->value)+strlen(tmp2->value)+strlen(s->name)+strlen(toto->value)+13)*sizeof(char));
+      sprintf(file_url,"%s/%s/%s_%i.%s",tmp3->value,tmp2->value,s->name,cpid+100000,toto->value);
+      addToMap(request_outputs->content,"Reference",file_url);
+      toto=getMap(request_outputs->content,"value");
+      if(toto!=NULL)
+	fwrite(toto->value,sizeof(char),strlen(toto->value),ofile);
+      fclose(ofile);
+      free(file_name);
+      free(file_url);
+    }
     map *r_inputs=getMap(s->content,"serviceProvider");
 #ifdef DEBUG
@@ -1979,5 +1295,5 @@
     dumpMaps(m);
 #endif
-    printProcessResponse1(m,request_inputs1,cpid,
+    printProcessResponse(m,request_inputs1,cpid,
 			  s,r_inputs->value,res,
 			  request_inputs,
@@ -2007,14 +1323,12 @@
       else
 	sprintf(mime,"Content-Type: text/plain; charset=utf-8\r\nStatus: 200 OK\r\n\r\n");
-    printf(mime);
-    toto=getMapFromMaps(request_outputs,
-			request_outputs->name,"value");
+    printf("%s",mime);
+    toto=getMap(request_outputs->content,"value");
     if(mi!=NULL && strncmp(mi->value,"image",5)==0){
-      map* rs=getMapFromMaps(request_outputs,
-			     request_outputs->name,"size");
+      map* rs=getMapFromMaps(request_outputs,request_outputs->name,"size");
       fwrite(toto->value,atoi(rs->value),1,stdout);
     }
     else
-      printf(toto->value);
+      printf("%s",toto->value);
 #ifdef DEBUG
     dumpMap(toto);
@@ -2045,5 +1359,5 @@
 }
 
-void addDefaultValues(maps** out,elements* in,maps* m,char* type){
+char* addDefaultValues(maps** out,elements* in,maps* m,char* type){
   elements* tmpInputs=in;
   maps* out1=*out;
@@ -2052,46 +1366,44 @@
     if(tmpMaps==NULL){
       map* tmpMap1=getMap(tmpInputs->content,"minOccurs");
-      if(strcmp(type,"inputs")==0)
+      if(strncmp(type,"inputs",6)==0)
 	if(tmpMap1!=NULL && atoi(tmpMap1->value)>=1){
-	  char tmps[1024];
-	  sprintf(tmps,"The <%s> argument was not specified in DataInputs but defined as requested in ZOO ServicesProvider configuration file, please correct your query or the ZOO Configuration file.",tmpInputs->name);
-	  map* tmpe=createMap("text",tmps);
-	  addToMap(tmpe,"code","MissingParameterValue");
-	  printExceptionReportResponse(m,tmpe);
-	  exit(1);
+	  return tmpInputs->name;
 	}
-      tmpMaps=(maps*)malloc(MAPS_SIZE);
-      tmpMaps->name=strdup((char*)tmpInputs->name);
-      tmpMaps->content=NULL;
+      maps* tmpMaps2=(maps*)malloc(MAPS_SIZE);
+      tmpMaps2->name=strdup((char*)tmpInputs->name);
+      tmpMaps2->content=NULL;
+      tmpMaps2->next=NULL;
       iotype* tmpIoType=tmpInputs->defaults;
       while(tmpIoType!=NULL){
-	tmpMaps->content=tmpIoType->content;
-	tmpMaps->content->next;
+	addMapToMap(&tmpMaps2->content,tmpIoType->content);
 	tmpIoType=tmpIoType->next;
       }
-      map *tmpMap=getMap(tmpMaps->content,"value");
+      map *tmpMap=getMap(tmpMaps2->content,"value");
       if(tmpMap==NULL)
-	addToMap(tmpMaps->content,"value","NULL");
-      tmpMaps->next=NULL;
-      dumpMaps(tmpMaps);
+	addToMap(tmpMaps2->content,"value","NULL");
       if(out1==NULL){
-	out1=(maps*)malloc(MAPS_SIZE);
-	out1->name=tmpMaps->name;
-	out1->content=tmpMaps->content;
-	out1->next=NULL;
-	*out=out1;
+	*out=dupMaps(&tmpMaps2);
       }
       else
-	addMapsToMaps(&out1,tmpMaps);
+	addMapsToMaps(&out1,tmpMaps2);
+      freeMaps(&tmpMaps2);
+      free(tmpMaps2);
+      tmpMaps2=NULL;
     }
     else{
       map* tmpContent=tmpInputs->defaults->content;
+      
+      map* cval=NULL;
+      
       while(tmpContent!=NULL){
-	map* tmpIn=getMap(out1->content,tmpContent->name);
-	if(tmpIn==NULL)
-	  if(out1->content==NULL)
-	    out1->content=createMap(tmpContent->name,tmpContent->value);
+	if((cval=getMap(tmpMaps->content,tmpContent->name))==NULL){
+#ifdef DEBUG
+	  fprintf(stderr,"addDefaultValues %s => %s\n",tmpContent->name,tmpContent->value);
+#endif
+	  if(tmpMaps->content==NULL)
+	    tmpMaps->content=createMap(tmpContent->name,tmpContent->value);
 	  else
-	    addToMap(out1->content,tmpContent->name,tmpContent->value);
+	    addToMap(tmpMaps->content,tmpContent->name,tmpContent->value);
+	}
 	tmpContent=tmpContent->next;
       }
@@ -2099,3 +1411,4 @@
     tmpInputs=tmpInputs->next;
   }
-}
+  return "";
+}
Index: trunk/zoo-kernel/service_internal.h
===================================================================
--- trunk/zoo-kernel/service_internal.h	(revision 8)
+++ trunk/zoo-kernel/service_internal.h	(revision 9)
@@ -53,25 +53,27 @@
 #include <libxml/parser.h>
   static char* SERVICE_URL;
+  static xmlNsPtr usedNs[5];
+  static char* nsName[5];
+  static int nbNs=0;
+
 
   void URLDecode(char *);
   char *url_encode(char *);
+  char* getEncoding(maps*);
+
+  int zooXmlSearchForNs(char*);
+  int zooXmlAddNs(xmlNodePtr,char*,char*);
+  void zooXmlCleanupNs();
   
   void printExceptionReportResponse(maps*,map*);
-  void printProcessResponse1(maps*,map*,int,service*,char*,int,maps*,maps*);
-  void printProcessResponse(maps*,int,service*,char*,int,map*,map*);
-  void printGetCapabilitiesResponse(service**,int,char*,maps*);
+  void printProcessResponse(maps*,map*,int,service*,char*,int,maps*,maps*);
   xmlNodePtr printGetCapabilitiesHeader(xmlDocPtr,char*,maps*);
   void printGetCapabilitiesForProcess(maps*,xmlNodePtr,service*);
-  void printGetCapabilitiesDocument(xmlDocPtr);
-  void printDescribeProcessResponse(service*,char*);
   xmlNodePtr printDescribeProcessHeader(xmlDocPtr,char*,maps*);
-  void printDescribeProcessForProcess(maps*,xmlNodePtr,service**,int);
-  void printDescribeProcessDocument(xmlDocPtr);
-  void printDocument(xmlDocPtr);
+  void printDescribeProcessForProcess(maps*,xmlNodePtr,service*,int);
+  void printDocument(maps*,xmlDocPtr,int);
   void printDescription(xmlNodePtr,xmlNsPtr,char*,map*);
-  void printIOType1(xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr,elements*,maps*,char*);
-  void printIOType(xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr,elements*,map*,char*);
+  void printIOType(xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr,elements*,maps*,char*);
   void printOutputDefinitions1(xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr,elements*,maps*,char*);
-  void printOutputDefinitions(xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr,elements*,map*,char*);
   
   void outputResponse(service*,maps*,maps*,map*,int,maps*,int);
@@ -79,5 +81,8 @@
   char *base64(const unsigned char*,int);
 
-  void addDefaultValues(maps**,elements*,maps*,char*);
+  char* addDefaultValues(maps**,elements*,maps*,char*);
+
+  /*defined in zoo_loader.c*/ 
+  int errorException(maps *m, const char *message, const char *errorcode);
 
 #ifdef __cplusplus
Index: trunk/zoo-kernel/service_internal_java.c
===================================================================
--- trunk/zoo-kernel/service_internal_java.c	(revision 8)
+++ trunk/zoo-kernel/service_internal_java.c	(revision 9)
@@ -86,4 +86,6 @@
     addToMap(err,"code","NoApplicableCode");
     printExceptionReportResponse(m,err);
+    freeMap(&err);
+    free(err);
     (*jvm)->DestroyJavaVM(jvm);
     return 1;
@@ -148,6 +150,8 @@
 	addToMap(err,"code","NoApplicableCode");
 	printExceptionReportResponse(m,err);
+	freeMap(&err);
+	free(err);
 	(*jvm)->DestroyJavaVM(jvm);
-	return 1;
+	return -1;
       }
     }
@@ -155,16 +159,20 @@
       char tmpS[1024];
       sprintf(tmpS, "Cannot find function %s \n", s->name);
-      map* tmps=createMap("text",tmpS);
-      printExceptionReportResponse(m,tmps);
+      map* err=createMap("text",tmpS);
+      printExceptionReportResponse(m,err);
+      freeMap(&err);
+      free(err);
       (*jvm)->DestroyJavaVM(jvm);
-      exit(-1);
+      return -1;
     }
   }else{
     char tmpS[1024];
     sprintf(tmpS, "Cannot find function %s \n", tmp->value);
-    map* tmps=createMap("text",tmpS);
-    printExceptionReportResponse(m,tmps);
-    if (PyErr_Occurred())
-      PyErr_Print();
+    map* err=createMap("text",tmpS);
+    printExceptionReportResponse(m,err);
+    freeMap(&err);
+    free(err);
+    (*jvm)->DestroyJavaVM(jvm);
+    return -1;
   }
   (*jvm)->DestroyJavaVM(jvm);
@@ -312,8 +320,11 @@
     cmap->next=NULL;
     if(final_res==NULL){
-      final_res=cmap;
+      final_res=dupMaps(&cmap);
     }else
-      addMapsToMaps(final_res,cmap);
+      addMapsToMaps(&final_res,cmap);
     final_res->next=NULL;
+    freeMaps(&cmap);
+    free(cmap);
+    cmap=NULL;
     res=NULL;
   }
Index: trunk/zoo-kernel/service_internal_js.c
===================================================================
--- trunk/zoo-kernel/service_internal_js.c	(revision 8)
+++ trunk/zoo-kernel/service_internal_js.c	(revision 9)
@@ -30,4 +30,8 @@
 		   maps **inputs,maps **outputs)
 {
+  maps* main=*main_conf;
+  maps* _inputs=*inputs;
+  maps* _outputs=*outputs;
+
   /* The class of the global object. */
   JSClass global_class = {
@@ -47,7 +51,7 @@
   if (rt == NULL)
     return 1;
-
+  
   /* Create a context. */
-  cx = JS_NewContext(rt, 8192);
+  cx = JS_NewContext(rt,8192);
   if (cx == NULL){
     return 1;
@@ -78,5 +82,5 @@
   map* tmpm1=getMap(request,"metapath");
   map* tmpm2=getMap(s->content,"serviceProvider");
-  char *filename[strlen(tmpm1->value)+strlen(tmpm2->value)+6];
+  char filename[strlen(tmpm1->value)+strlen(tmpm2->value)+6];
   char ntmp[1024];
   getcwd(ntmp,1024);
@@ -87,8 +91,8 @@
   uint16 lineno;
   jsval rval;
-  FILE *jsfile=fopen(filename,"rb");
+  FILE *jsfile=fopen(filename,"r");
   JSBool ok ;
-  JSScript *script = JS_CompileFileHandle(cx, global, filename, jsfile);
-  if(script){
+  JSScript *script = JS_CompileFileHandle(cx, global, filename,jsfile);
+  if(script!=NULL){
     (void)JS_ExecuteScript(cx, global, script, &rval);
   }
@@ -102,12 +106,16 @@
     JS_DestroyRuntime(rt);
     JS_ShutDown();
+    fclose(jsfile);
     exit(-1);
   }
   /* Call a function in obj's scope. */
   jsval argv[3];
-  argv[0] = OBJECT_TO_JSVAL(JSObject_FromMaps(cx,*main_conf));
-  argv[1] = OBJECT_TO_JSVAL(JSObject_FromMaps(cx,*inputs));
-  argv[2] = OBJECT_TO_JSVAL(JSObject_FromMaps(cx,*outputs));
-  jsval rval1;
+  JSObject *jsargv1=JSObject_FromMaps(cx,*main_conf);
+  argv[0] = OBJECT_TO_JSVAL(jsargv1);
+  JSObject *jsargv2=JSObject_FromMaps(cx,*inputs);
+  argv[1] = OBJECT_TO_JSVAL(jsargv2);
+  JSObject *jsargv3=JSObject_FromMaps(cx,*outputs);
+  argv[2] = OBJECT_TO_JSVAL(jsargv3);
+  jsval rval1=JSVAL_NULL;
 #ifdef JS_DEBUG
   fprintf(stderr, "object %p\n", (void *) argv[2]);
@@ -121,5 +129,5 @@
 
   JSObject *d;
-  if (ok==JS_TRUE) {
+  if (ok==JS_TRUE && JSVAL_IS_OBJECT(rval1)==JS_TRUE) {
 #ifdef JS_DEBUG
     fprintf(stderr,"Function run sucessfully !\n");
@@ -127,35 +135,30 @@
     /* Should get a number back from the service function call. */
     ok = JS_ValueToObject(cx, rval1, &d);
-    if (ok==JS_TRUE) {
-#ifdef JS_DEBUG
-      fprintf(stderr,"Function run sucessfully !\n");
-#endif
-      /*char tmpres[10];
-      sprintf(tmpres,"%p",(void *)d);
-      res=atoi(tmpres);*/
-    }
   }else{
     /* Unable to run JS function */
     char tmp1[1024];
-    //sprintf(tmp1,"Unable to run %s from the JavScript file %s",s->name,filename);
+    if(strlen(dbg)==0)
+      sprintf(dbg,"No result was found after the function call");
     sprintf(tmp1,"Unable to run %s from the JavScript file %s : \n %s",s->name,filename,dbg);
     fprintf(stderr,"%s",tmp1);
     map* err=createMap("text",tmp1);
-    addMapToMap(err,createMap("code","NoApplicableCode"));
+    addToMap(err,"code","NoApplicableCode");
     printExceptionReportResponse(*main_conf,err);
+    freeMap(&err);
+    free(err);
     JS_DestroyContext(cx);
     JS_DestroyRuntime(rt);
     JS_ShutDown();
+    // Should return -1 here but the unallocation won't work from zoo_service_loader.c line 1847
     exit(-1);
   }
 
   jsval t=OBJECT_TO_JSVAL(d);
-  //JSVAL_TO_OBJECT(t);
-  if(JS_IsArrayObject(cx,t)){
+  if(JS_IsArrayObject(cx,d)){
 #ifdef JS_DEBUG
     fprintf(stderr,"An array was returned !\n");
 #endif
-    jsdouble len;
-    if((JS_GetArrayLength(cx, t, &len)==JS_FALSE)){
+    jsint len;
+    if((JS_GetArrayLength(cx, d, &len)==JS_FALSE)){
 #ifdef JS_DEBUG
       fprintf(stderr,"outputs array is empty\n");
@@ -163,5 +166,5 @@
     }
     jsval tmp1;
-    JSBool hasResult=JS_GetElement(cx,t,0,&tmp1);
+    JSBool hasResult=JS_GetElement(cx,d,0,&tmp1);
     res=JSVAL_TO_INT(tmp1);
 #ifdef JS_DEBUG
@@ -169,50 +172,44 @@
 #endif
     jsval tmp2;
-    JSBool hasElement=JS_GetElement(cx,t,1,&tmp2);
-    out=mapsFromJSObject(cx,tmp2);
-    *outputs=out;
+    JSBool hasElement=JS_GetElement(cx,d,1,&tmp2);
+    if(hasElement==JS_TRUE){
+      *outputs=mapsFromJSObject(cx,tmp2);
+    }
   }
   else{
-    //#ifdef JS_DEBUG
-    fprintf(stderr,"The service didn't return an array !\n");
-    //#endif
+#ifdef JS_DEBUG
+    fprintf(stderr,"The serice didn't return an array !\n");
+#endif
     jsval tmp1;
-    JSBool hasResult=JS_GetProperty(cx,t,"result",&tmp1);
+    JSBool hasResult=JS_GetProperty(cx,d,"result",&tmp1);
     res=JSVAL_TO_INT(tmp1);
 
-    //#ifdef JS_DEBUG
+#ifdef JS_DEBUG
     fprintf(stderr," * %d * \n",res);
-    //#endif
+#endif
     jsval tmp2;
-    JSBool hasElement=JS_GetProperty(cx,t,"outputs",&tmp2);
+    JSBool hasElement=JS_GetProperty(cx,d,"outputs",&tmp2);
     if(!hasElement)
       fprintf(stderr,"No outputs property returned\n");
-    if(JS_IsArrayObject(cx,tmp2))
+    if(JS_IsArrayObject(cx,JSVAL_TO_OBJECT(tmp2)))
       fprintf(stderr,"outputs is array an as expected\n");
     else
       fprintf(stderr,"outputs is not an array as expected\n");
-    out=mapsFromJSObject(cx,tmp2);
+    *outputs=mapsFromJSObject(cx,tmp2);
 #ifdef JS_DEBUG
     dumpMaps(out);
 #endif
-    *outputs=out;
-  }
-
-  *inputs=mapsFromJSObject(cx,argv[1]);
-  *main_conf=mapsFromJSObject(cx,argv[0]);
-
-  
-  //}
-  //else
-  // ERROR 
-  //;
+  }
 
   /* Cleanup. */
-  JS_MaybeGC(cx);
+  // The JS_MaybeGC call imply segmentation fault
+  //JS_MaybeGC(cx);
   JS_DestroyScript(cx, script);
-  JS_DestroyContext(cx);
+  // If we use the DestroyContext as requested to release memory then we get 
+  // issue getting back the main configuration maps after coming back to the 
+  // runRequest function ...
+  //JS_DestroyContext(cx);
   JS_DestroyRuntime(rt);
   JS_ShutDown();
-  fflush(stderr);
 #ifdef JS_DEBUG
   fprintf(stderr,"Returned value %d\n",res);
@@ -223,4 +220,6 @@
 JSObject* JSObject_FromMaps(JSContext *cx,maps* t){
   JSObject *res = JS_NewArrayObject(cx, 0, NULL);
+  if(res==NULL)
+    fprintf(stderr,"Array Object is NULL!\n");
   maps* tmp=t;
   while(tmp!=NULL){
@@ -247,5 +246,5 @@
   while(tmpm!=NULL){
     jsval jsstr = STRING_TO_JSVAL(JS_NewString(cx,tmpm->value,strlen(tmpm->value)));
-    JS_SetProperty(cx, resf, tmpm->name,&jsstr);
+    JS_SetProperty(cx, res, tmpm->name,&jsstr);
 #ifdef JS_DEBUG
     fprintf(stderr,"%s => %s\n",tmpm->name,tmpm->value);
@@ -259,38 +258,32 @@
   maps *res=NULL;
   maps *tres=NULL;
-  JSVAL_TO_OBJECT(t);
+  jsint oi=0;
+  JSObject* tt=JSVAL_TO_OBJECT(t);
 #ifdef JS_DEBUG
   fprintf(stderr,"Is finally an array ?\n");
-#endif
-  if(JS_IsArrayObject(cx,t)){
-#ifdef JS_DEBUG
+  if(JS_IsArrayObject(cx,tt)){
     fprintf(stderr,"Is finally an array !\n");
-#endif
-  }
-#ifdef JS_DEBUG
+  }
   else
     fprintf(stderr,"Is not an array !\n");
 #endif
-  jsdouble len;
-  if((JS_GetArrayLength(cx, t, &len)==JS_FALSE)){
+  jsint len;
+  JSBool hasLen=JS_GetArrayLength(cx, tt, &len);
+  if(hasLen==JS_FALSE){
 #ifdef JS_DEBUG
     fprintf(stderr,"outputs array is empty\n");
 #endif
   }
-  int i=0;
-  char tmp[10];
-  sprintf(tmp,"%d",len);
-  int clen=atoi(tmp);
 #ifdef JS_DEBUG
   fprintf(stderr,"outputs array length : %d\n",len);
 #endif
-  for(i=0;i<len;i++){
-#ifdef JS_DEBUG
-    fprintf(stderr,"outputs array length : %d step %d\n",len,i);
+  for(oi=0;oi < len;oi++){
+#ifdef JS_DEBUG
+    fprintf(stderr,"outputs array length : %d step %d \n",len,oi);
 #endif
     jsval tmp1;
-    JSBool hasElement=JS_GetElement(cx,t,i,&tmp1);
-    JSVAL_TO_OBJECT(tmp1);
-    JSIdArray *idp=JS_Enumerate(cx,tmp1);
+    JSBool hasElement=JS_GetElement(cx,tt,oi,&tmp1);
+    JSObject *otmp1=JSVAL_TO_OBJECT(tmp1);
+    JSIdArray *idp=JS_Enumerate(cx,otmp1);
     if(idp!=NULL) {
       int index;
@@ -300,5 +293,5 @@
 #endif
       for (index=0,argNum=idp->length;index<argNum;index++) { 
-	jsid* id = idp->vector[index];
+	jsval id = idp->vector[index];
 	jsval vp;
 	JSString* str; 
@@ -310,10 +303,10 @@
 	len1 = JS_GetStringLength(jsmsg);
 #ifdef JS_DEBUG
-	fprintf(stderr,"Enumerate id : %d => %s\n",i,JS_GetStringBytes(jsmsg));
-#endif
-	jsval nvp;
-	if((JS_GetProperty(cx, tmp1, JS_GetStringBytes(jsmsg), &nvp)==JS_FALSE))
-#ifdef JS_DEBUG
-	fprintf(stderr,"Enumerate id : %d => %s => No more value\n",i,JS_GetStringBytes(jsmsg));
+	fprintf(stderr,"Enumerate id : %d => %s\n",oi,JS_GetStringBytes(jsmsg));
+#endif
+	jsval nvp=JSVAL_NULL;
+	if((JS_GetProperty(cx, JSVAL_TO_OBJECT(tmp1), JS_GetStringBytes(jsmsg), &nvp)==JS_FALSE))
+#ifdef JS_DEBUG
+	fprintf(stderr,"Enumerate id : %d => %s => No more value\n",oi,JS_GetStringBytes(jsmsg));
 #endif
 	if(JSVAL_IS_OBJECT(nvp)){
@@ -333,5 +326,5 @@
 	  fprintf(stderr,"JSVAL NVP1J IS OBJECT\n");
 #endif
-	  tres=(maps*)malloc(sizeof(maps*));
+	  tres=(maps*)malloc(MAPS_SIZE);
 	  tres->name=strdup(JS_GetStringBytes(jsmsg));
 	  tres->content=mapFromJSObject(cx,nvp1j);
@@ -341,7 +334,10 @@
 #endif
 	  if(res==NULL)
-	    res=tres;
+	    res=dupMaps(&tres);
 	  else
 	    addMapsToMaps(&res,tres);
+	  freeMaps(&tres);
+	  free(tres);
+	  tres=NULL;
 #ifdef JS_DEBUG
 	  dumpMaps(res);
@@ -363,5 +359,5 @@
 map* mapFromJSObject(JSContext *cx,jsval t){
   map *res=NULL;
-  JSIdArray *idp=JS_Enumerate(cx,t);
+  JSIdArray *idp=JS_Enumerate(cx,JSVAL_TO_OBJECT(t));
 #ifdef JS_DEBUG
   fprintf(stderr,"Properties %p\n",(void*)t);
@@ -374,5 +370,5 @@
 #endif
     for (index=0,argNum=idp->length;index<argNum;index++) { 
-      jsid* id = idp->vector[index];
+      jsval id = idp->vector[index];
       jsval vp;
       JSString* str; 
@@ -384,5 +380,5 @@
       len = JS_GetStringLength(jsmsg);
       jsval nvp;
-      JS_GetProperty(cx, t, JS_GetStringBytes(jsmsg), &nvp);
+      JS_GetProperty(cx, JSVAL_TO_OBJECT(t), JS_GetStringBytes(jsmsg), &nvp);
       jsmsg1 = JS_ValueToString(cx,nvp);
       len1 = JS_GetStringLength(jsmsg1);
@@ -390,8 +386,13 @@
       fprintf(stderr,"Enumerate id : %d [ %s => %s ]\n",index,JS_GetStringBytes(jsmsg),JS_GetStringBytes(jsmsg1));
 #endif
-      if(res!=NULL)
-	addMapToMap(&res,createMap(JS_GetStringBytes(jsmsg),JS_GetStringBytes(jsmsg1)));
-      else
+      if(res!=NULL){
+	fprintf(stderr,"%s - %s\n",JS_GetStringBytes(jsmsg),JS_GetStringBytes(jsmsg1));
+	addToMap(res,JS_GetStringBytes(jsmsg),JS_GetStringBytes(jsmsg1));
+      }
+      else{
 	res=createMap(JS_GetStringBytes(jsmsg),JS_GetStringBytes(jsmsg1));
+	res->next=NULL;
+      }
+      dumpMap(res);
     }
   }
@@ -401,5 +402,4 @@
   return res;
 }
-
 
 /* The error reporter callback. */
Index: trunk/zoo-kernel/service_internal_python.c
===================================================================
--- trunk/zoo-kernel/service_internal_python.c	(revision 8)
+++ trunk/zoo-kernel/service_internal_python.c	(revision 9)
@@ -25,115 +25,4 @@
 #include "service_internal_python.h"
 
-int python_support(maps* m,service* s,int argc,char** argv,map *inputs,map *outputs){
-  Py_Initialize();
-  PyObject *pName, *pModule, *pFunc;
-  pName = PyString_FromString(argv[2]);
-  pModule = PyImport_Import(pName);
-  int i;
-  if (pModule != NULL) {
-    pFunc=PyObject_GetAttrString(pModule,argv[4]);
-    if (pFunc && PyCallable_Check(pFunc)){
-      PyDictObject* arg1=PyDict_FromMap(inputs);
-      PyDictObject* arg2=PyDict_FromMap(outputs);
-      PyObject *pArgs=PyTuple_New(2);
-      PyObject *pValue;
-      PyTuple_SetItem(pArgs, 0, (PyObject *)arg1);
-      PyTuple_SetItem(pArgs, 1, (PyObject *)arg2);
-      pValue = PyString_FromString(argv[argc-1]);
-#ifdef DEBUG
-      fprintf(stderr,"Function successfully loaded\n");
-#endif	
-      /**
-       * Need to check if we need to fork to load a status enabled 
-       */
-      if(strcmp(PyString_AsString(pValue),"bg")!=0){
-#ifdef DEBUG
-	fprintf(stderr,"RUN IN NORMAL MODE \n");
-#endif
-	pValue = PyObject_CallObject(pFunc, pArgs);
-	if (pValue != NULL) {
-	  inputs=mapFromPyDict(arg1);
-	  outputs=mapFromPyDict(arg2);
-#ifdef DEBUG
-	  fprintf(stderr,"Result of call: %i\n", PyInt_AsLong(pValue));
-	  dumpMap(inputs);
-	  dumpMap(outputs);
-#ifndef WIN32
-	  fprintf(stderr,"printProcessResponse(%i,\"%s\",%i,inputs,outputs);",getpid(),argv[1],PyInt_AsLong(pValue));
-#endif
-#endif
-	  printProcessResponse(m,getpid(),s,argv[2],PyInt_AsLong(pValue),inputs,outputs);
-	}
-      }
-      else{
-	pid_t pid;
-#ifdef WIN32
-	pid = 0;
-#else
-	pid = fork ();
-#endif
-	if (pid > 0) {
-	  /* dady */
-	  printProcessResponse(m,pid,s,argv[2],SERVICE_STARTED,inputs,outputs);
-	}else if (pid == 0) {
-	  /* son */
-#ifdef DEBUG
-	  fprintf(stderr,"RUN IN BACKGROUND MODE \n");
-#endif
-	  char tmp1[256];
-	  sprintf(tmp1,"service/temp/%s_%d.xml",argv[2],getpid());
-#ifndef WIN32
-	  stdout =
-#endif
-		  freopen(tmp1 , "w+" , stdout);
-	  printProcessResponse(m,getpid(),s,argv[2],SERVICE_STARTED,inputs,outputs);
-	  fflush(stdout);
-	  pValue = PyObject_CallObject(pFunc, pArgs);
-	  if (pValue != NULL) {
-	    rewind(stdout);
-	    inputs=mapFromPyDict(arg1);
-	    outputs=mapFromPyDict(arg2);
-#ifdef DEBUG
-	    fprintf(stderr,"Result of call: %ld\n", PyInt_AsLong(pValue));
-	    dumpMap(inputs);
-	    dumpMap(outputs);
-	    fprintf(stderr,"printProcessResponse(%i,%s,%i,inputs,outputs);",s,getpid(),argv[2],PyInt_AsLong(pValue));
-#endif
-//	    sleep(6);
-	    printProcessResponse(m,getpid(),s,argv[2],PyInt_AsLong(pValue),inputs,outputs);
-	  }
-	  exit(1);
-	} else {
-	  /* error */
-	}
-      }
-      Py_DECREF(pArgs);
-      Py_DECREF(pValue);
-#ifdef DEBUG
-      fprintf(stderr,"Function ran successfully\n");
-#endif	
-    }
-    else{
-      char tmpS[1024];
-      sprintf(tmpS, "Cannot find function %s \n", argv[4]);
-      map* tmps=createMap("text",tmpS);
-      printExceptionReportResponse(m,tmps);
-      //fprintf(stderr, "Cannot find function %s \n", argv[2]);
-      exit(-1);
-    }
-  }else{
-    char tmpS[1024];
-    sprintf(tmpS, "Cannot find function %s \n", argv[4]);
-    map* tmps=createMap("text",tmpS);
-    printExceptionReportResponse(m,tmps);
-    //fprintf(stderr, "Cannot find function %s \n", argv[4]);
-    if (PyErr_Occurred())
-      PyErr_Print();
-
-  }
-  Py_Finalize();
-  return 2;
-}
-
 int zoo_python_support(maps** main_conf,map* request,service* s,maps **real_inputs,maps **real_outputs){
   maps* m=*main_conf;
@@ -144,12 +33,14 @@
   map* tmp=NULL;
   tmp=getMapFromMaps(*main_conf,"env","PYTHONPATH");
-  char *python_path=NULL;
+  char *python_path;
+  fprintf(stderr,"PYTHON SUPPORT \n");
+  fflush(stderr);
   if(tmp!=NULL){
-	  python_path=(char*)malloc((1+strlen(tmp->value))*sizeof(char));
-	  sprintf(python_path,"%s",tmp->value);
+    fprintf(stderr,"PYTHON SUPPORT (%i)\n",strlen(tmp->value));
+    python_path=(char*)malloc((strlen(tmp->value))*sizeof(char));
+    sprintf(python_path,"%s",tmp->value);
   }
   else{
-	python_path=(char*)malloc(2*sizeof(char));
-	python_path=".";
+    python_path=strdup(".");
   }
   tmp=NULL;
@@ -158,7 +49,7 @@
   if(tmp!=NULL && strcmp(tmp->value,"")!=0)
 #ifdef WIN32
-	  sprintf(pythonpath,"%s/%s/;%s",ntmp,tmp->value,python_path);
+    sprintf(pythonpath,"%s/%s/;%s",ntmp,tmp->value,python_path);
 #else
-	  sprintf(pythonpath,"%s/%s/:%s",ntmp,tmp->value,python_path);
+  sprintf(pythonpath,"%s/%s/:%s",ntmp,tmp->value,python_path);
 #endif
   else
@@ -166,9 +57,9 @@
     sprintf(pythonpath,"%s;%s",ntmp,python_path);
 #else
-    sprintf(pythonpath,"%s:%s",ntmp,python_path);
-#endif
-#ifdef DEBUG
-  fprintf(stderr,"PYTHONPATH=%s\n",pythonpath);
-#endif
+  sprintf(pythonpath,"%s:%s",ntmp,python_path);
+#endif
+  //#ifdef DEBUG
+    fprintf(stderr,"PYTHONPATH=%s\n",pythonpath);
+  //#endif
 #ifndef WIN32
   setenv("PYTHONPATH",pythonpath,1);
@@ -178,10 +69,16 @@
   free(python_path);
   free(pythonpath);
-  //
+
   Py_Initialize();
   PyObject *pName, *pModule, *pFunc;
   tmp=getMap(s->content,"serviceProvider");
-  //if(tmp!=NULL)
-  pName = PyString_FromString(tmp->value);
+  if(tmp!=NULL)
+    pName = PyString_FromString(tmp->value);
+  else{
+    map* err=createMap("text","Unable to parse serviceProvider please check your zcfg file.");
+    addToMap(err,"code","NoApplicableCode");
+    printExceptionReportResponse(m,err);
+    exit(-1);
+  }
   pModule = PyImport_Import(pName);
   int i;
@@ -202,28 +99,27 @@
 #ifdef DEBUG
       fprintf(stderr,"RUN IN NORMAL MODE \n");
-      //fflush(stderr);
+      fflush(stderr);
 #endif
       pValue = PyObject_CallObject(pFunc, pArgs);
       if (pValue != NULL) {
 	res=PyInt_AsLong(pValue);
-	/*inputs=mapsFromPyDict(arg2);
-	dumpMaps(inputs);*/
-	outputs=mapsFromPyDict(arg3);
-	*real_outputs=outputs;
-
+	freeMaps(real_outputs);
+	free(*real_outputs);
+	//*real_inputs=mapsFromPyDict(arg2);
+	//createMapsFromPyDict(real_outputs,arg3);
+	*real_outputs=mapsFromPyDict(arg3);
 #ifdef DEBUG
 	fprintf(stderr,"Result of call: %i\n", PyInt_AsLong(pValue));
 	dumpMaps(inputs);
 	dumpMaps(outputs);
-	fprintf(stderr,"printProcessResponse(%i,\"%s\",%i,inputs,outputs);",
-		getpid(),tmp->value,PyInt_AsLong(pValue));
-	dumpMaps(outputs);
-#endif
+#endif
+	Py_DECREF(arg1);
+	Py_DECREF(arg2);
+	Py_DECREF(arg3);
+      	Py_DECREF(pArgs);
 	Py_DECREF(pValue);
 	Py_XDECREF(pFunc);
-      	Py_DECREF(pArgs);
 	Py_DECREF(pModule);
-      }else{
-	  
+      }else{	  
 	PyObject *ptype,*pvalue, *ptraceback;
 	PyErr_Fetch(&ptype, &pvalue, &ptraceback);
@@ -268,5 +164,4 @@
       map* tmps=createMap("text",tmpS);
       printExceptionReportResponse(m,tmps);
-      //fprintf(stderr, "Cannot find function %s \n", argv[2]);
       Py_XDECREF(pFunc);
       Py_DECREF(pModule);
@@ -275,13 +170,15 @@
   } else{
     char tmpS[1024];
-    sprintf(tmpS, "Cannot find function %s \n", tmp->value);
+    sprintf(tmpS, "Python module %s cannot be loaded.\n", tmp->value);
     map* tmps=createMap("text",tmpS);
     printExceptionReportResponse(m,tmps);
-    //fprintf(stderr, "Cannot find function %s \n", argv[4]);
     if (PyErr_Occurred())
       PyErr_Print();
     exit(-1);
   } 
+#ifndef DEBUG
+  // Failed when DEBUG is defined
   Py_Finalize();
+#endif
   return res;
 }
@@ -329,8 +226,8 @@
 	    PyString_AsString(key),PyString_AsString(value));
 #endif
-    if(cursor!=NULL){
+    while(cursor!=NULL){
       cursor=cursor->next;
     }
-    cursor=(maps*)malloc(sizeof(maps*));
+    cursor=(maps*)malloc(MAPS_SIZE);
     cursor->name=PyString_AsString(key);
 #ifdef DEBUG
Index: trunk/zoo-kernel/service_internal_python.h
===================================================================
--- trunk/zoo-kernel/service_internal_python.h	(revision 8)
+++ trunk/zoo-kernel/service_internal_python.h	(revision 9)
@@ -40,7 +40,7 @@
 
 maps* mapsFromPyDict(PyDictObject* t);
+void createMapsFromPyDict(maps**,PyDictObject*);
 map* mapFromPyDict(PyDictObject* t);
 
-int python_support(maps*,service*,int,char**,map *,map *);
 int zoo_python_support(maps**,map*,service*,maps**,maps**);
 
Index: trunk/zoo-kernel/ulinet.c
===================================================================
--- trunk/zoo-kernel/ulinet.c	(revision 8)
+++ trunk/zoo-kernel/ulinet.c	(revision 9)
@@ -215,4 +215,5 @@
   if(handle.handle)
     curl_easy_cleanup(handle.handle);
+  curl_global_cleanup();
 }
 
@@ -233,5 +234,5 @@
       break;
     default:
-      sprintf(filename,"/tmp/HTCcache%d",(int)time(NULL));
+      sprintf(filename,"/tmp/ZOO_Cache%d",(int)time(NULL));
       printf("file=%s",filename);
 #ifdef MSG_LAF_VERBOSE
